# Contributing

Contributions of all types are welcome. We use GitHub as our bug and feature tracker both for code and for other aspects of the library (documentation, the wiki, etc.).

When contributing to this repository, please first discuss the change you wish to make via issue,
email, or any other method with the owners of this repository before making a change. The best way to ask  questions, discuss is to send an email to our [mailing list][mailing list]

Please note we have a code of conduct, please follow it in all your interactions with the project.

## Filing issues

When in doubt, file an issue. We'd rather close a few duplicate issues than let a problem go unnoticed.
Similarly if you support a particular feature request, feel free to let us know by commenting on the issue or [subscribing][subscribing] to the issue.

To file a new issue, please use our issue template and fill out the template as much as possible (remove irrelevant parts).
The more information you can provide, the more likely we are to be able help.

## Contributing code

Pull requests are welcome for all parts of the codebase, especially the integration libraries.
You can find instructions on building the project in [README.md][readme].
Our code style is defined in Intellij project files in the repo and also by our Dart/Flutter analysis options config.
If you'd like to submit code, but can't get the style checks to pass, feel free to put up your pull request anyway and we can help you fix the style issues.
If you'd like to contribute code, you will need to sign [Google's individual contributor license agreement][contributor license] which will be asked when you create the PR by [googlebot](https://github.com/googlebot) should you forget it.

## Labels

Labels on issues are managed by contributors, you don't have to worry about them. Here's a list of what they mean:

 * **bug**: feature that should work, but doesn't
 * **enhancement**: minor tweak/addition to existing behavior
 * **feature**: new behavior, bigger than enhancement
 * **question**: no need to modify this libary to fix the issue, usually a usage problem
 * **reproducible**: has enough information to very easily reproduce
 * **repro-needed**: we need some code to be able to reproduce and debug locally, otherwise there's not much we can do
 * **duplicate**: there's another issue which already covers/tracks this
 * **wontfix**: working as intended, or won't be fixed due to compatibility or other reasons
 * **invalid**: there isn't enough information to make a verdict, or unrelated to this libary
 * **non-library**: issue is not in the core library code, but rather in documentation, samples, build process, releases

## Code of Conduct

This Code of Conduct is adapted from the [Contributor Covenant][contributor covenant], version 1.4,
available at [http://contributor-covenant.org/version/1/4][contributor covenant version]

[readme]: README.md
[contributor covenant]: http://contributor-covenant.org
[contributor covenant version]: http://contributor-covenant.org/version/1/4/
[contributor license]: https://developers.google.com/open-source/cla/individual
[mailing list]: https://groups.google.com/g/evtsp_group
[subscribing]: https://help.github.com/articles/subscribing-to-conversations 